<?php
/**
 * @file
 * The rules hook and actions
 *
 * Define each action, messages to users, etc.
 */

/**
 * Implementation of hook_rules_action_info().
 */
function gcm_rules_action_info() {
  return array(
    'gcm_action_send_message' => array(
      'label' => t('Send GCM message'),
      'module' => 'Google Cloud Messaging',
      'eval input' => array('tokens', 'keyValue'),
    ),
  );
}

/**
 * Implementation of hook_rules_event_info().
 */
function gcm_rules_event_info() {
  return array(
    'gcm_event_registration_id_error' => array(
      'label' => t('Got registration ID with an error'),
      'module' => 'Google Cloud Messaging',
      'arguments' => array(
        'registration_id' => array(
          'label' => t('Registration id'),
          'type' => 'string',
        ),
        'error' => array(
          'label' => t('Error type'),
          'type' => 'string',
        ),
      ),
    ),
  );
}

function gcm_action_send_message($settings) {

    // Get form values
    $tokens = strip_tags($settings['tokens']);

    $keyValues = $settings['keyValue'];

    $gcm_message = array();
    foreach (explode(",", $keyValues) as $keyValue) {
      $temp = explode("=", $keyValue);
      $key = $temp[0];
      $value = $temp[1];
      if (isset($key) && isset($value)) {
        $gcm_message[$key] = $value;
      }
    }
    $delay_while_idle = false;
    if ($settings['delay_while_idle'] === 1) {
      $delay_while_idle = true;
    }

    $time_to_live = null;
    $collapse_key = null;
    if (!empty($settings['collapse_key'])) {
      $collapse_key = $settings['collapse_key'];
      if (!empty($settings['time_to_live']) && intval($settings['time_to_live']) > 0) {
        $time_to_live = intval($settings['time_to_live']);
      }
    }
    gcm_send_message(array_unique(explode(',', $tokens)), $gcm_message, $delay_while_idle, $time_to_live, $collapse_key);
}
