<?php

/**
 * @file
 * The forms for the rules
 *
 * Standard definition via the Form API
 */

/**
 * Action drupal message configuration form.
 */
function gcm_action_send_message_form($settings = array(), &$form) {

  $form['settings']['tokens'] = array(
    '#type' => 'textfield',
    '#title' => t('Tokens'),
    '#default_value' => $settings['tokens'],
    '#description' => t("Tokens, comma delimeter"),
  );
  $form['settings']['keyValue'] = array(
    '#type' => 'textfield',
    '#title' => t('Key-Value'),
    '#default_value' => $settings['keyValue'],
    '#description' => t("Comma delimetered key-value pairs, for example key1=value1,key2=value"),
  );
  $form['settings']['delay_while_idle'] = array(
    '#type' => 'checkbox',
    '#title' => t('Delay while idle'),
    '#default_value' => $settings['delay_while_idle'],
    '#description' => t("If included, indicates that the message should not be sent immediately if the device is idle."),
  );
  $form['settings']['collapse_key'] = array(
    '#type' => 'textfield',
    '#title' => t('Collapse key'),
    '#default_value' => $settings['collapse_key'],
    '#description' => t('An arbitrary string (such as "Updates Available") that is used to collapse a group of like messages when the device is offline, so that only the last message gets sent to the client.'),
  );
  $form['settings']['time_to_live'] = array(
    '#type' => 'textfield',
    '#title' => t('Time to live'),
    '#default_value' => $settings['time_to_live'],
    '#description' => t("How long (in seconds) the message should be kept on GCM storage if the device is offline. Requires collapse key to be regarded."),
  );
  $form['support'] = array(
    '#type' => 'item',
    '#title' => t('Support'),
    '#value' => t('Detailed support regarding to the different options can be found in <a href="@link">Google Cloud Messaging documentation</a>', array('@link' => url('http://developer.android.com/guide/google/gcm/index.html'))),
  );
}